
# The minimum and maximum «lineHeight» values to show
minValue = 0
maxValue = 2

# The animation duration
Framer.Defaults.Animation.time = 0.5

# 1.25 is the default value (Design only allows for 1 decimal)
theTextLayer.lineHeight = 1.25


# Visible background for the Text Layer
theTextLayer.backgroundColor = "#eee"

# Adjust the Text Layer’s height automatically
theTextLayer.autoHeight = yes


# Functions for the slider

# round number to a set amount
round = (number, nearest) ->
	Math.round(number / nearest) * nearest

# get the amount of decimals of a number
retr_dec = (num) ->
	return ("#{num}".split('.')[1] || []).length

# Setup title
title.template =
	v: ""
	d: "«default»"

# Slider
slider = new SliderComponent
	height: 5
	width: Screen.width - 50
	knobSize: 25
	backgroundColor: "rgba(255,255,255,0.5)"
	x: 25
	maxY: Screen.height - buttonA.height - 55
	min: minValue
	max: maxValue
slider.fill.backgroundColor = "#fff"

slider.value = theTextLayer.lineHeight

slider.onValueChange ->
	theTextLayer.lineHeight = @value

# Setup buttons

for button in [buttonA, buttonB, buttonC]
	# Resize horizontally
	button.width = ( Screen.width - 100 ) / 3
	# Change color on tap and release
	button.onTouchStart ->
		@backgroundColor = "#fff"
		@children[0].color = artboard.backgroundColor
	button.onTouchEnd ->
		@backgroundColor = artboard.backgroundColor
		@children[0].color = "#fff"

# Setup animations

# animate to minimum value
buttonA.children[0].text = minValue
buttonA.onTap ->
	slider.animate
		value: minValue

# animate to default value
defaultValue = theTextLayer.lineHeight

buttonB.children[0].text = defaultValue
buttonB.onTap ->
	slider.animate
		value: defaultValue

# animate to maximum value
buttonC.children[0].text = maxValue
buttonC.onTap ->

	slider.animate
		value: maxValue

# listen to layer changes
roundBy = 0.01
theTextLayer.on "change:lineHeight", ->
	valueToShow = Utils.round (round @lineHeight, roundBy), (retr_dec roundBy)
	if valueToShow is defaultValue
		title.template =
			v: ""
			d: "«default»"
	else
		title.template =
			v: valueToShow
			d: ""
